diff --git a/include/notcurses/notcurses.h b/include/notcurses/notcurses.h
index cc9814866b..05303dd181 100644
--- a/include/notcurses/notcurses.h
+++ b/include/notcurses/notcurses.h
@@ -853,6 +853,10 @@ API int notcurses_render(struct notcurses* nc);
 // rapidly than the terminal is updated.
 API int notcurses_render_nblock(struct notcurses* nc);
 
+// Block until all rendered frames have been rasterized. Only meaningful
+// following the use of notcurses_render_nblock().
+API void notcurses_render_flush(struct notcurses* nc);
+
 // Write the last rendered frame, in its entirety, to 'fp'. If
 // notcurses_render() has not yet been called, nothing will be written.
 API int notcurses_render_to_file(struct notcurses* nc, FILE* fp);
diff --git a/src/demo/zoo.c b/src/demo/zoo.c
index 7faffa38b3..87033309b7 100644
--- a/src/demo/zoo.c
+++ b/src/demo/zoo.c
@@ -412,6 +412,7 @@ reader_demo(struct notcurses* nc){
   ncselector_destroy(selector, NULL);
   ncmultiselector_destroy(mselector);
   ncreader_destroy(reader, NULL);
+  notcurses_render_flush(nc);
   if(notcurses_cursor_disable(nc)){
     return -1;
   }
diff --git a/src/lib/internal.h b/src/lib/internal.h
index df42cd10b6..e93b034102 100644
--- a/src/lib/internal.h
+++ b/src/lib/internal.h
@@ -304,6 +304,8 @@ typedef struct notcurses {
   int lfdimy;     // lfdimx/lfdimy are 0 until first render
   egcpool pool;   // duplicate EGCs into this pool
 
+  pthread_t writer_tid; // tid of rasterizer thread, for nonblocking rendering
+
   int cursory;    // desired cursor placement according to user. -1 is a don't-
   int cursorx;    //  care, otherwise moved here after each render.
 
diff --git a/src/lib/render.c b/src/lib/render.c
index 3fb6ca9545..dc7998b572 100644
--- a/src/lib/render.c
+++ b/src/lib/render.c
@@ -1023,7 +1023,7 @@ typedef struct rendered_frame {
   } state;
 } rendered_frame;
 
-static pthread_t writer_tid;
+// FIXME these all need to be taken up into the notcurses struct
 // we have two frames available. the rendering client renders to the primary if
 // it is available. if both are full, the secondary can be blown away.
 static int next_to_render = 0;
@@ -1031,6 +1031,15 @@ static rendered_frame rframes[1];
 static pthread_cond_t writer_cond = PTHREAD_COND_INITIALIZER;
 static pthread_mutex_t writer_lock = PTHREAD_MUTEX_INITIALIZER;
 
+void notcurses_render_flush(notcurses* nc){
+  pthread_mutex_lock(&writer_lock);
+  rendered_frame* rframe = &rframes[next_to_render];
+  while(rframe->state != UNUSED){
+    pthread_cond_wait(&writer_cond, &writer_lock);
+  }
+  pthread_mutex_unlock(&writer_lock);
+}
+
 // this writer thread is spun up at startup, and signaled by
 // notcurses_render_nblock() when a frame is ready.
 static void*
@@ -1044,6 +1053,7 @@ writer_thread(void* vnc){
     pthread_mutex_lock(&writer_lock);
     if(inloop){
       rframe->state = UNUSED;
+      pthread_cond_signal(&writer_cond);
     }
     rframe = &rframes[next_to_raster];
     while(rframe->state != RENDERED){
@@ -1203,6 +1213,7 @@ int notcurses_cursor_enable(notcurses* nc, int y, int x){
   }
   nc->cursory = y;
   nc->cursorx = x;
+fprintf(stderr, "ENABLED CURSOR AT %d/%d\n", nc->cursory, nc->cursorx);
   return 0;
 }
 
@@ -1224,9 +1235,21 @@ int notcurses_cursor_disable(notcurses* nc){
 }
 
 int render_init(notcurses* nc){
-  if(pthread_create(&writer_tid, NULL, writer_thread, nc)){
+  if(pthread_create(&nc->writer_tid, NULL, writer_thread, nc)){
     logerror(nc, "Error launching raster thread (%s)\n", strerror(errno));
     return -1;
   }
   return 0;
 }
+
+int render_stop(notcurses* nc){
+  void* ret;
+  if(pthread_cancel(nc->writer_tid)){
+    logerror(nc, "Couldn't cancel rasterizer (%s)\n", strerror(errno));
+  }
+  if(pthread_join(nc->writer_tid, &ret)){
+    logerror(nc, "Couldn't join rasterizer (%s)\n", strerror(errno));
+    return -1;
+  }
+  return 0;
+}
